Only in 4.5.0/qmake/: Makefile
Only in 4.5.0/qmake/: TAGS
Only in 4.5.0/qmake/: borland_bmake.obj
diff -urw /cygdrive/c/Qt/4.5.0/qmake/generators/win32/msvc_objectmodel.cpp 4.5.0/qmake/generators/win32/msvc_objectmodel.cpp
--- /cygdrive/c/Qt/4.5.0/qmake/generators/win32/msvc_objectmodel.cpp	2009-02-25 16:32:32.000000000 -0500
+++ 4.5.0/qmake/generators/win32/msvc_objectmodel.cpp	2009-03-29 22:43:42.496160500 -0400
@@ -1266,7 +1266,7 @@
     displayHash("UNLOAD"); displayHash("NOBIND"); displayHash("no"); displayHash("NOSTATUS"); displayHash("STATUS");
     displayHash("AM33"); displayHash("ARM"); displayHash("CEE"); displayHash("EBC"); displayHash("IA64"); displayHash("X86"); displayHash("X64"); displayHash("M32R");
     displayHash("MIPS"); displayHash("MIPS16"); displayHash("MIPSFPU"); displayHash("MIPSFPU16"); displayHash("MIPSR41XX"); displayHash("PPC");
-    displayHash("SH3"); displayHash("SH3DSP"); displayHash("SH4"); displayHash("SH5"); displayHash("THUMB"); displayHash("TRICORE"); displayHash("EXPORTS");
+    displayHash("SH3"); displayHash("SH3DSP"); displayHash("SH4"); displayHash("SH5"); displayHash("THUMB"); displayHash("TRICORE"); displayHash("X64"); displayHash("EXPORTS");
     displayHash("LINES"); displayHash("REF"); displayHash("NOREF"); displayHash("ICF"); displayHash("WIN98"); displayHash("NOWIN98");
     displayHash("CONSOLE"); displayHash("EFI_APPLICATION"); displayHash("EFI_BOOT_SERVICE_DRIVER"); displayHash("EFI_ROM"); displayHash("EFI_RUNTIME_DRIVER"); displayHash("NATIVE");
     displayHash("POSIX"); displayHash("WINDOWS"); displayHash("WINDOWSCE"); displayHash("NET"); displayHash("CD"); displayHash("NO");
@@ -1394,8 +1394,10 @@
         case 0x0005bb6: // X86
             TargetMachine = machineX86;
             break;
-        // so we put the others in AdditionalOptions...
         case 0x0005b94: // X64
+	    TargetMachine = machineX64;
+	    break;
+        // so we put the others in AdditionalOptions...
         case 0x0046063: // AM33
         case 0x000466d: // ARM
         case 0x0004795: // CEE
@@ -2606,10 +2608,12 @@
             << attrS(_Keyword, tool.Keyword)
             << attrS(_SccProjectName, tool.SccProjectName)
             << attrS(_SccLocalPath, tool.SccLocalPath)
-            << tag(_Platforms)
-                << tag(_Platform)
-                    << attrS(_Name, tool.PlatformName)
-            << closetag(_Platforms)
+	    << tag(_Platforms);
+    for(int i = 0; i < tool.PlatformNames.count(); ++i)
+	xml     << tag(_Platform)
+		    << attrS(_Name, tool.PlatformNames.at(i))
+                << closetag(_Platform);
+    xml     << closetag(_Platforms)
             << tag(_Configurations);
     // Output each configuration
     for (int i = 0; i < tool.SingleProjects.count(); ++i)
Only in 4.5.0/qmake/generators/win32: msvc_objectmodel.cpp~
diff -urw /cygdrive/c/Qt/4.5.0/qmake/generators/win32/msvc_objectmodel.h 4.5.0/qmake/generators/win32/msvc_objectmodel.h
--- /cygdrive/c/Qt/4.5.0/qmake/generators/win32/msvc_objectmodel.h	2009-02-25 16:32:32.000000000 -0500
+++ 4.5.0/qmake/generators/win32/msvc_objectmodel.h	2009-03-29 22:36:32.938834300 -0400
@@ -297,8 +297,9 @@
     linkProgressLibs
 };
 enum machineTypeOption {
-    machineNotSet,
-    machineX86
+    machineNotSet = -1,
+    machineX86 = 1,
+    machineX64 = 17
 };
 enum midlCharOption {
     midlCharUnsigned,
@@ -1041,7 +1042,7 @@
     QString                 Keyword;
     QString                 SccProjectName;
     QString                 SccLocalPath;
-    QString                 PlatformName;
+    QStringList             PlatformNames;
 
     // Single projects
     QList<VCProjectSingleConfig>  SingleProjects;
Only in 4.5.0/qmake/generators/win32: msvc_objectmodel.h~
diff -urw /cygdrive/c/Qt/4.5.0/qmake/generators/win32/msvc_vcproj.cpp 4.5.0/qmake/generators/win32/msvc_vcproj.cpp
--- /cygdrive/c/Qt/4.5.0/qmake/generators/win32/msvc_vcproj.cpp	2009-02-25 16:32:32.000000000 -0500
+++ 4.5.0/qmake/generators/win32/msvc_vcproj.cpp	2009-03-29 22:50:12.445328500 -0400
@@ -381,6 +381,10 @@
                 const QString &compilerName = singleProject->ExtraCompilersFiles.at(j).Name;
                 if (!mergedProject.ExtraCompilers.contains(compilerName))
                     mergedProject.ExtraCompilers += compilerName;
+
+		const QString &platformName = singleProject->PlatformName;
+		if (!mergedProject.PlatformNames.contains(platformName))
+		    mergedProject.PlatformNames += platformName;
             }
         }
 
@@ -394,7 +398,6 @@
         mergedProject.Keyword = project->first("VCPROJ_KEYWORD");
         mergedProject.SccProjectName = mergedProjects.at(0)->vcProject.SccProjectName;
         mergedProject.SccLocalPath = mergedProjects.at(0)->vcProject.SccLocalPath;
-        mergedProject.PlatformName = mergedProjects.at(0)->vcProject.PlatformName;
 
         XmlOutput xmlOut(t);
         xmlOut << mergedProject;
@@ -912,7 +915,10 @@
 
     vcProject.Keyword = project->first("VCPROJ_KEYWORD");
     if (project->isEmpty("CE_SDK") || project->isEmpty("CE_ARCH")) {
-        vcProject.PlatformName = (vcProject.Configuration.idl.TargetEnvironment == midlTargetWin64 ? "Win64" : "Win32");
+      if (vcProject.Configuration.linker.TargetMachine == machineX64)
+        vcProject.PlatformName = "x64";
+      else
+	vcProject.PlatformName = "Win32";
     } else {
         vcProject.PlatformName = project->values("CE_SDK").join(" ") + " (" + project->first("CE_ARCH") + ")";
     }
@@ -963,7 +969,7 @@
     if (conf.Name.isEmpty())
         conf.Name = isDebug ? "Debug" : "Release";
     if (project->isEmpty("CE_SDK") || project->isEmpty("CE_ARCH")) {
-        conf.Name += (conf.idl.TargetEnvironment == midlTargetWin64 ? "|Win64" : "|Win32");
+        conf.Name += (conf.linker.TargetMachine == machineX64 ? "|x64" : "|Win32");
     } else {
         conf.Name += "|" + project->values("CE_SDK").join(" ") + " (" + project->first("CE_ARCH") + ")";
     }
Only in 4.5.0/qmake/generators/win32: msvc_vcproj.cpp~
Only in 4.5.0/qmake/: main.obj
Only in 4.5.0/qmake/: makefile.obj
Only in 4.5.0/qmake/: makefiledeps.obj
Only in 4.5.0/qmake/: meta.obj
Only in 4.5.0/qmake/: metamakefile.obj
Only in 4.5.0/qmake/: mingw_make.obj
Only in 4.5.0/qmake/: msvc_dsp.obj
Only in 4.5.0/qmake/: msvc_nmake.obj
Only in 4.5.0/qmake/: msvc_objectmodel.obj
Only in 4.5.0/qmake/: msvc_vcproj.obj
Only in 4.5.0/qmake/: option.obj
Only in 4.5.0/qmake/: pbuilder_pbx.obj
Only in 4.5.0/qmake/: project.obj
Only in 4.5.0/qmake/: projectgenerator.obj
Only in 4.5.0/qmake/: property.obj
Only in 4.5.0/qmake/: qabstractfileengine.obj
Only in 4.5.0/qmake/: qbitarray.obj
Only in 4.5.0/qmake/: qbuffer.obj
Only in 4.5.0/qmake/: qbytearray.obj
Only in 4.5.0/qmake/: qbytearraymatcher.obj
Only in 4.5.0/qmake/: qcryptographichash.obj
Only in 4.5.0/qmake/: qdatastream.obj
Only in 4.5.0/qmake/: qdatetime.obj
Only in 4.5.0/qmake/: qdir.obj
Only in 4.5.0/qmake/: qdiriterator.obj
Only in 4.5.0/qmake/: qfile.obj
Only in 4.5.0/qmake/: qfileinfo.obj
Only in 4.5.0/qmake/: qfsfileengine.obj
Only in 4.5.0/qmake/: qfsfileengine_iterator.obj
Only in 4.5.0/qmake/: qfsfileengine_iterator_win.obj
Only in 4.5.0/qmake/: qfsfileengine_win.obj
Only in 4.5.0/qmake/: qglobal.obj
Only in 4.5.0/qmake/: qhash.obj
Only in 4.5.0/qmake/: qiodevice.obj
Only in 4.5.0/qmake/: qlibraryinfo.obj
Only in 4.5.0/qmake/: qlinkedlist.obj
Only in 4.5.0/qmake/: qlistdata.obj
Only in 4.5.0/qmake/: qlocale.obj
Files /cygdrive/c/Qt/4.5.0/qmake/qmake.exe and 4.5.0/qmake/qmake.exe differ
Only in 4.5.0/qmake/: qmake.ilk
Only in 4.5.0/qmake/: qmake.pdb
Only in 4.5.0/qmake/: qmalloc.obj
Only in 4.5.0/qmake/: qmap.obj
Only in 4.5.0/qmake/: qmetatype.obj
Only in 4.5.0/qmake/: qnumeric.obj
Only in 4.5.0/qmake/: qregexp.obj
Only in 4.5.0/qmake/: qscriptasm.obj
Only in 4.5.0/qmake/: qscriptast.obj
Only in 4.5.0/qmake/: qscriptastvisitor.obj
Only in 4.5.0/qmake/: qscriptclass.obj
Only in 4.5.0/qmake/: qscriptclassdata.obj
Only in 4.5.0/qmake/: qscriptclasspropertyiterator.obj
Only in 4.5.0/qmake/: qscriptcompiler.obj
Only in 4.5.0/qmake/: qscriptcontext.obj
Only in 4.5.0/qmake/: qscriptcontext_p.obj
Only in 4.5.0/qmake/: qscriptcontextinfo.obj
Only in 4.5.0/qmake/: qscriptecmaarray.obj
Only in 4.5.0/qmake/: qscriptecmaboolean.obj
Only in 4.5.0/qmake/: qscriptecmacore.obj
Only in 4.5.0/qmake/: qscriptecmadate.obj
Only in 4.5.0/qmake/: qscriptecmaerror.obj
Only in 4.5.0/qmake/: qscriptecmafunction.obj
Only in 4.5.0/qmake/: qscriptecmaglobal.obj
Only in 4.5.0/qmake/: qscriptecmamath.obj
Only in 4.5.0/qmake/: qscriptecmanumber.obj
Only in 4.5.0/qmake/: qscriptecmaobject.obj
Only in 4.5.0/qmake/: qscriptecmaregexp.obj
Only in 4.5.0/qmake/: qscriptecmastring.obj
Only in 4.5.0/qmake/: qscriptengine.obj
Only in 4.5.0/qmake/: qscriptengine_p.obj
Only in 4.5.0/qmake/: qscriptengineagent.obj
Only in 4.5.0/qmake/: qscriptextenumeration.obj
Only in 4.5.0/qmake/: qscriptextvariant.obj
Only in 4.5.0/qmake/: qscriptfunction.obj
Only in 4.5.0/qmake/: qscriptgrammar.obj
Only in 4.5.0/qmake/: qscriptlexer.obj
Only in 4.5.0/qmake/: qscriptparser.obj
Only in 4.5.0/qmake/: qscriptprettypretty.obj
Only in 4.5.0/qmake/: qscriptstring.obj
Only in 4.5.0/qmake/: qscriptsyntaxchecker.obj
Only in 4.5.0/qmake/: qscriptvalue.obj
Only in 4.5.0/qmake/: qscriptvalueimpl.obj
Only in 4.5.0/qmake/: qscriptvalueiterator.obj
Only in 4.5.0/qmake/: qscriptvalueiteratorimpl.obj
Only in 4.5.0/qmake/: qsettings.obj
Only in 4.5.0/qmake/: qsettings_win.obj
Only in 4.5.0/qmake/: qstring.obj
Only in 4.5.0/qmake/: qstringlist.obj
Only in 4.5.0/qmake/: qtemporaryfile.obj
Only in 4.5.0/qmake/: qtextstream.obj
Only in 4.5.0/qmake/: qurl.obj
Only in 4.5.0/qmake/: quuid.obj
Only in 4.5.0/qmake/: qvariant.obj
Only in 4.5.0/qmake/: qvector.obj
Only in 4.5.0/qmake/: qvsnprintf.obj
Only in 4.5.0/qmake/: unixmake.obj
Only in 4.5.0/qmake/: unixmake2.obj
Only in 4.5.0/qmake/: winmakefile.obj
Only in 4.5.0/qmake/: xmloutput.obj